import { ah as popScheduler, ai as from } from './message-CUt9VVap.js';
import { g as getSessionStorage, j as storageObservable } from './fetch-CBLapmcO.js';
import { b as browser } from './browser-polyfill-DYFaknZ4.js';
import { s as switchMap } from './switchMap-bmwRNpaI.js';

function of() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var scheduler = popScheduler(args);
    return from(args, scheduler);
}

const PREFIX = 'tab-available';
function getTabAvailableKey(tabId) {
    return `${PREFIX}:${tabId}`;
}
async function setTabAvailable(tabId, state) {
    await getSessionStorage().setItem(getTabAvailableKey(tabId), state);
    await browser.action.setBadgeText({
        tabId,
        text: '✓'
    });
}
async function removeTabAvailable(tabId, state) {
    const value = await getSessionStorage().getItem(getTabAvailableKey(tabId));
    if (value !== String(state)) {
        return;
    }
    await getSessionStorage().removeItem(getTabAvailableKey(tabId));
    await browser.action.setBadgeText({
        tabId,
        text: ''
    });
}
function tabAvailableObservable(tabId$) {
    return tabId$.pipe(switchMap((tabId)=>{
        if (!tabId) {
            return of(undefined);
        }
        const key = getTabAvailableKey(tabId);
        return storageObservable(getSessionStorage(), key);
    }));
}

export { removeTabAvailable as r, setTabAvailable as s, tabAvailableObservable as t };
